#include <iostream>
#include <vector>
#include <cassert>
#include <cstdio>
using namespace std;

#define TASK "player"

typedef long long ll;

struct Info {
    ll l, r, sm;
    int f, length;
    Info() {}
    Info(ll l, ll r, int f):l(l), r(r), f(f) {
        sm = 1LL * (r - l) * f;
        length = r - l;
    }

    int len() const {
        return length;
    }

    ll sum() const {
        return sm;
    }
};

int main() {
    freopen(TASK".in", "r", stdin);
    freopen(TASK".out", "w", stdout);

    int n, v, ff;
    scanf("%d%d%d", &n, &v, &ff);
    ll f = ff;
    assert(v == 1);

    vector<Info> a;
    ll sumT = 0;
    for (int i = 0; i < n; ++i) {
        int t, k;
        scanf("%d%d", &t, &k);
        for (int j = 0; j < k; ++j) {
            int l, r, fij;
            scanf("%d%d%d", &l, &r, &fij);
            a.push_back(Info(l + sumT, r + sumT, fij));
        }
        sumT += t;
    }
    for (int i = 0; i < n; ++i)
        if (f - a[i].sum() > 0)
            f -= a[i].sum();
        else {
            printf("%.10f\n", a[i].l + 1.0 * f / a[i].f);
            return 0;
        }
    printf("-1\n");
    return 0;
}